// use this site "http://jsonviewer.stack.hu/" in order to convert data.json into one line string

var metadata = '{"avaliable_devices":["CC3135","CC3235"],"primary_conditions":[{"name":"System Event","id":"0x81","length":"0x0C","available_sub_conditions":null,"available_actions":["Send Transceiver","Send UDP","Send TCP","Increment counter","Set counter","Timer control","Set GPIO (output)","Enter hibernate","Delete all profiles","Set connection policy"]},{"name":"Counter threshold","id":"0x82","length":"0x10","available_sub_conditions":null,"available_actions":["Send Transceiver","Send UDP","Send TCP","Increment counter","Set counter","Timer control","Set GPIO (output)","Enter hibernate","Delete all profiles","Set connection policy"]},{"name":"Internal Error","id":"0x84","length":"0x0C","available_sub_conditions":["None"],"available_actions":["None"]},{"name":"Timer Expiration","id":"0x86","length":"0x0C","available_sub_conditions":null,"available_actions":["Send Transceiver","Send UDP","Send TCP","Increment counter","Set counter","Timer control","Set GPIO (output)","Enter hibernate","Delete all profiles","Set connection policy"]},{"name":"Pre-init event","id":"0x87","length":"0x0C","available_sub_conditions":null,"available_actions":["Set role"]}],"sub_conditions":[{"name":"None","id":"0x00000000"},{"name":"Started role","id":"0x00000001"},{"name":"Counter value","id":"0x0CCCNN02"},{"name":"GPIO state","id":"0x00PPNN03"}],"actions":[{"name":"None","id":"0x0D","available_primary_condition_as_next_step":null},{"name":"Send Transceiver","id":"0x01","available_primary_condition_as_next_step":null},{"name":"Send UDP","id":"0x02","available_primary_condition_as_next_step":null},{"name":"Send TCP","id":"0x03","available_primary_condition_as_next_step":null},{"name":"Increment counter","id":"0x05","available_primary_condition_as_next_step":{"name":"Counter threshold","link_field":{"act_elem":"ti_widget_droplist_inc_cout_counter_number","act_db":"inc_count_counter_number","prim_cond_elem":"ti_widget_droplist_ct_counter_number","prim_cond_db":"counter_number"}}},{"name":"Set counter","id":"0x06","available_primary_condition_as_next_step":{"name":"Counter threshold","link_field":{"act_elem":"ti_widget_droplist_set_count_counter_number","act_db":"set_count_counter_number","prim_cond_elem":"ti_widget_droplist_ct_counter_number","prim_cond_db":"counter_number"}}},{"name":"Timer control","id":"0x07","available_primary_condition_as_next_step":{"name":"Timer Expiration","link_field":{"act_elem":"ti_widget_droplist_tmr_ctrl_timer_number","act_db":"tmr_ctrl_timer_number","prim_cond_elem":"ti_widget_droplist_timer_expiration_number","prim_cond_db":"timer_number"}}},{"name":"Set GPIO (output)","id":"0x08","available_primary_condition_as_next_step":null},{"name":"Enter hibernate","id":"0x0C","available_primary_condition_as_next_step":null},{"name":"Set role","id":"0x41","available_primary_condition_as_next_step":null},{"name":"Delete all profiles","id":"0x0A","available_primary_condition_as_next_step":null},{"name":"Set connection policy","id":"0x09","available_primary_condition_as_next_step":null}],"pads":{"CC3130":{"in":"4|5|8|9|10|12|13|23|24|26|27|28|29|40","out":"4|5|8|9|10|12|13|23|24|25|26|27|28|29|40"},"CC3135":{"in":"4|5|8|9|10|12|13|23|24|26|27|28|29|40","out":"4|5|8|9|10|12|13|23|24|25|26|27|28|29|40"},"CC3230":{"in":"5|6|8|9|10|12|13|14|15|16|22|26|27|40","out":"3|4|5|6|8|9|10|11|12|13|14|15|16|17|22|25|26|27|40"},"CC3235":{"in":"5|6|8|9|10|12|13|14|15|16|22|26|27|40","out":"3|4|5|6|8|9|10|11|12|13|14|15|16|17|22|25|26|27|40"}},"channels":{"24G":"1|2|3|4|5|6|7|8|9|10|11|12|13","5G":"36|38|40|42|44|46|48|149|151|153|155|157|159|161|165"},"rates":[{"name":"1 Mbps","value":"1"},{"name":"2 Mbps","value":"2"},{"name":"5.5 Mbps","value":"3"},{"name":"11 Mbps","value":"4"},{"name":"6 Mbps","value":"6"},{"name":"9 Mbps","value":"7"},{"name":"12 Mbps","value":"8"},{"name":"18 Mbps","value":"9"},{"name":"24 Mbps","value":"10"},{"name":"36 Mbps","value":"11"},{"name":"48 Mbps","value":"12"},{"name":"54 Mbps","value":"13"},{"name":"MCS_0","value":"14"},{"name":"MCS_1","value":"15"},{"name":"MCS_2","value":"16"},{"name":"MCS_3","value":"17"},{"name":"MCS_4","value":"18"},{"name":"MCS_5","value":"19"},{"name":"MCS_6","value":"20"},{"name":"MCS_7","value":"21"},{"name":"MAX_NUM_RATES","value":"255"}],"system_events":[{"name":"Invalid Command","code":"DEVICE_INVALIDCOMMAND","value":"0x0000"},{"name":"Init Complete","code":"DEVICE_INITCOMPLETE","value":"0x0008"},{"name":"Abrot","code":"DEVICE_ABORT","value":"0x000C"},{"name":"Stop Response","code":"DEVICE_STOP_ASYNC_RESPONSE","value":"0x0073"},{"name":"General Error","code":"DEVICE_DEVICE_ASYNC_GENERAL_ERROR","value":"0x0078"},{"name":"Flow Control Event","code":"DEVICE_FLOW_CTRL_ASYNC_EVENT","value":"0x0079"},{"name":"STA Connected","code":"WLAN_STA_ASYNCCONNECTEDRESPONSE","value":"0x0880"},{"name":"P@P Client Connected","code":"WLAN_P2PCL_ASYNCCONNECTEDRESPONSE","value":"0x0892"},{"name":"STA Disconnected","code":"WLAN_STA_ASYNCDISCONNECTEDRESPONSE","value":"0x0881"},{"name":"P2P Client Disconnected","code":"WLAN_P2PCL_ASYNCDISCONNECTEDRESPONSE","value":"0x0894"},{"name":"Provisioning Profile Added","code":"WLAN_PROVISIONING_PROFILE_ADDED_ASYNC_RESPONSE","value":"0x08B2"},{"name":"STA Added","code":"WLAN_ASYNC_STA_ADDED","value":"0x082E"},{"name":"P2P Client Added","code":"WLAN_ASYNC_P2PCL_ADDED","value":"0x0896"},{"name":"STA Removed","code":"WLAN_ASYNC_STA_REMOVED","value":"0x082F"},{"name":"P2P Client Removed","code":"WLAN_ASYNC_P2PCL_REMOVED","value":"0x0898"},{"name":"Reset Request","code":"DEVICE_RESET_REQUEST_ASYNC_EVENT","value":"0x0099"},{"name":"Provisioning Status","code":"WLAN_PROVISIONING_STATUS_ASYNC_EVENT","value":"0x089A"},{"name":"P2P Device Found","code":"WLAN_P2P_DEV_FOUND","value":"0x0830"},{"name":"P2P Connection Failed","code":"WLAN_P2P_CONNECTION_FAILED","value":"0x0831"},{"name":"P2P Negotiation Request Received","code":"WLAN_P2P_NEG_REQ_RECEIVED","value":"0x0832"},{"name":"Link Quality","code":"LINK_QUALITY_EVENT","value":"0x08BA"},{"name":"Socket Accept","code":"SOCKET_ACCEPTASYNCRESPONSE","value":"0x1003"},{"name":"Socket Accept V6","code":"SOCKET_ACCEPTASYNCRESPONSE_V6","value":"0x1203"},{"name":"Sockect Connect","code":"SOCKET_CONNECTASYNCRESPONSE","value":"0x1006"},{"name":"Socket Select","code":"SOCKET_SELECTASYNCRESPONSE","value":"0x1007"},{"name":"Socket Receved","code":"SOCKET_RECVASYNCRESPONSE","value":"0x100A"},{"name":"Socket Receved From","code":"SOCKET_RECVFROMASYNCRESPONSE","value":"0x100B"},{"name":"Socket Receved From V6","code":"SOCKET_RECVFROMASYNCRESPONSE_V6","value":"0x120B"},{"name":"Socket TX Failed","code":"SOCKET_TXFAILEDASYNCRESPONSE","value":"0x100E"},{"name":"Socket Event","code":"SOCKET_SOCKETASYNCEVENT","value":"0x100F"},{"name":"Socket Close","code":"SOCKET_SOCKETCLOSEASYNCEVENT","value":"0x1010"},{"name":"DNS Get Host By Name","code":"NETAPP_DNSGETHOSTBYNAMEASYNCRESPONSE","value":"0x1820"},{"name":"DNS Get Host By Name V6","code":"NETAPP_DNSGETHOSTBYNAMEASYNCRESPONSE_V6","value":"0x1A20"},{"name":"MDNS Get Host By Service","code":"NETAPP_MDNSGETHOSTBYSERVICEASYNCRESPONSE","value":"0x1835"},{"name":"DNS Get Host By Address","code":"NETAPP_DNSGETHOSTBYADDRASYNCRESPONSE","value":"0x1826"},{"name":"Ping Report Request","code":"NETAPP_PINGREPORTREQUESTRESPONSE","value":"0x1822"},{"name":"IP Acquired","code":"NETAPP_IPACQUIRED","value":"0x1825"},{"name":"IP Acquired V6","code":"NETAPP_IPACQUIRED_V6","value":"0x1A25"},{"name":"iP V4 Lost","code":"NETAPP_IPV4_LOST","value":"0x1832"},{"name":"IP V6 Lost","code":"NETAPP_IPV6_LOST_V6","value":"0x1A32"},{"name":"DHCP IP V4 Acquire Timeout","code":"NETAPP_DHCP_IPV4_ACQUIRE_TIMEOUT","value":"0x1833"},{"name":"IP Leased","code":"NETAPP_IP_LEASED","value":"0x182C"},{"name":"IP Released","code":"NETAPP_IP_RELEASED","value":"0x182D"},{"name":"HTTP Get","code":"NETAPP_HTTPGETTOKENVALUE","value":"0x182E"},{"name":"HTTP Post","code":"NETAPP_HTTPPOSTTOKENVALUE","value":"0x1830"},{"name":"IP Collision","code":"NETAPP_IP_COLLISION","value":"0x1831"},{"name":"No IP Collision Detected","code":"NETAPP_NO_IP_COLLISION_DETECTED","value":"0x18C4"},{"name":"No Local IP Collision Detected V6","code":"NETAPP_NO_LOCAL_IP_COLLISION_DETECTED_V6","value":"0x1AC5"},{"name":"No Global IP Collision Detected V6","code":"NETAPP_NO_GLOBAL_IP_COLLISION_DETECTED_V6","value":"0x1AC6"},{"name":"CTEST","code":"NETAPP_CTESTASYNCRESPONSE","value":"0x182A"},{"name":"NETAPP Request","code":"NETAPP_REQUEST","value":"0x1878"},{"name":"NETAPP Receive","code":"NETAPP_RECEIVE","value":"0x187B"},{"name":"RX Filter","code":"WLAN_RX_FILTER_ASYNC_RESPONSE","value":"0x089D"},{"name":"Util Command","code":"NETUTIL_COMMANDASYNCRESPONSE","value":"0x30C1"}]}';

var appData = JSON.parse(metadata);
console.log(appData);

var get_avaliable_devices = function () {
    var devices = [];

    for (var device_index in appData.avaliable_devices) {
        if (!appData.avaliable_devices[device_index].startsWith('_')) {
            devices.push(appData.avaliable_devices[device_index]);
        }
    }

    return devices;
}

var get_input_pad_numbers = function (device_type) {
    var pads = appData.pads;
    return pads[device_type].in;
};

var get_output_pad_numbers = function (device_type) {
    var pads = appData.pads;
    return pads[device_type].out;
};

var get_system_events_list = function () {
    var system_events = appData.system_events;
    var list_of_events = [];

    for (var event_index in system_events) {
        list_of_events.push(system_events[event_index].name);
    }

    return list_of_events;
};

var get_system_event_value_by_name = function (event_name) {
    var system_events = appData.system_events;

    var value = "";
    for (var i = 0; i < system_events.length; i++) {
        if (system_events[i].name === event_name) {
            value = system_events[i].value;
            break;
        }
    }

    return value;
};

var get_rates_list = function () {
    var rates = appData.rates;
    var list_of_rates = [];

    for (var rate_index in rates) {
        list_of_rates.push(rates[rate_index].name);
    }

    return list_of_rates;
};

var get_rate_value_by_name = function (rate_name) {
    var rates = appData.rates;

    var value = "";
    for (var i = 0; i < rates.length; i++) {
        if (rates[i].name === rate_name) {
            value = rates[i].value;
            break;
        }
    }

    return value;
};

var get_channels_by_device_type = function (device_type) {
    var last_device_type_char = device_type.slice(-1);
    var channels = "";

    if (last_device_type_char === "0") {
        channels = appData.channels['24G'];
    } else if (last_device_type_char === "5") {
        channels = appData.channels['24G'] + '|' + appData.channels['5G'];
    } else {
        channels = "ERROR"
    }

    return channels;
}

var get_24G_channels = function() {
    channels = appData.channels['24G'];
    return channels.split('|');
}

var get_5G_channels = function() {
    channels = appData.channels['5G'];
    return channels.split('|');
}
